#!/system/bin/sh
# Relljawa
# give credit if you use any part!!
# telegram dev @reljawa
# sync 
sync

# limit background system
echo 0-2 > /dev/cpuset/system-background/effective_cpus
echo 0-2 > /dev/cpuset/system-background/cpus

# cpu_ctrl
# Menentukan direktori yang akan dicek
directory=/sys/bus/cpu/devices/

# Memeriksa apakah direktori tersebut ada
if [ -d "$directory" ]; then
    # Melakukan iterasi pada semua file di dalam direktori
    for file in "$directory"/*; do
        if [ -d "$file" ]; then
            # Mengambil nomor CPU dari jalur file
            cpu=$(basename "$file")
            
            # Mengaktifkan core_ctl untuk CPU yang terdeteksi
            echo "40" > "$file/core_ctl/busy_down_thres"
            echo "60" > "$file/core_ctl/busy_up_thres"
            echo "500" > "$file/core_ctl/offline_delay_ms"
            echo "5" > "$file/core_ctl/max_cpus"
            echo "1" > "$file/core_ctl/enable"
            echo "1" > "$file/cpufreq/schedutil/rtg_boost_freq"
            echo "0" > "$file/cpufreq/schedutil/up_rate_limit_us"
            
        fi
    done
else
    echo "Direktori $directory tidak ditemukan."
fi

echo 0x40000004 > /proc/thread-self/personality
echo 1 > /proc/self/sched_init_task_load

# thermal zone
echo disabled > /sys/class/thermal/thermal_zone*/mode

  # Disable CPU hot-plugging
  # Credits @another_person
  echo "0" > /sys/devices/system/cpu/cpuquiet/tegra_cpuquiet/enable
  
  # Off Ramdumps
  # credits @another_person
  for ramdumps in /sys/module/subsystem_restart/parameters; do
    echo "0" > $ramdumps/enable_ramdumps
    echo "0" > $ramdumps/enable_mini_ramdumps
  done

# optimizing I/O
echo 0 > /sys/block/sda/queue/iosched/slice_idle

echo 1 > /dev/stune/schedtune.colocate
echo 1 > /dev/stune/schedtune.schedtune_boost
echo 1 > /dev/stune/rt/schedtune.schedtune_boost
echo 0 > /dev/stune/schedtune.sched_boost_no_override

echo 1 > /dev/cpuset/memory_spread_slab
echo 1 > /dev/cpuset/top-app/sched_relax_domain_level

echo 500 > /proc/sys/kernel/random/write_wakeup_threshold

echo 80 > /sys/bus/cpu/devices/cpu0/cpufreq/schedutil/hispeed_load

echo $(cat /sys/devices/system/cpu/cpu0/cpufreq/cpuinfo_max_freq) > /sys/bus/cpu/devices/cpu0/cpufreq/schedutil/rtg_boost_freq

echo "1 2 3 4" > /sys/bus/cpu/devices/cpu*/cache/index0/shared_cpu_list
echo "1 2 3 4" > /sys/bus/cpu/devices/cpu*/cache/index1/shared_cpu_list
echo "1 2 3 4" > /sys/bus/cpu/devices/cpu*/cache/index2/shared_cpu_list

# threads and cache
echo 0xff > /sys/bus/cpu/devices/cpu*/cache/index0/shared_cpu_map
echo 0xff > /sys/bus/cpu/devices/cpu*/cache/index1/shared_cpu_map
echo 0xff > /sys/bus/cpu/devices/cpu*/cache/index2/shared_cpu_map

echo 300 > /sys/kernel/gpu/gpu_min_clock

echo 0xff > /sys/bus/cpu/devices/cpu0/topology/thread_sibilings
echo 0xff > /sys/bus/cpu/devices/cpu1/topology/thread_sibilings
echo 0xff > /sys/bus/cpu/devices/cpu2/topology/thread_sibilings
echo 0xff > /sys/bus/cpu/devices/cpu3/topology/thread_sibilings
echo 0xff > /sys/bus/cpu/devices/cpu4/topology/thread_sibilings


echo 0xff > /sys/bus/cpu/devices/cpu0/topology/core_sibilings
echo 0xff > /sys/bus/cpu/devices/cpu1/topology/core_sibilings
echo 0xff > /sys/bus/cpu/devices/cpu2/topology/core_sibilings
echo 0xff > /sys/bus/cpu/devices/cpu3/topology/core_sibilings
echo 0xff > /sys/bus/cpu/devices/cpu4/topology/core_sibilings

echo 0-5 > /sys/bus/cpu/devices/cpu0/topology/core_sibilings_list
echo 0-5 > /sys/bus/cpu/devices/cpu1/topology/core_sibilings_list
echo 0-5 > /sys/bus/cpu/devices/cpu2/topology/core_sibilings_list
echo 0-5 > /sys/bus/cpu/devices/cpu3/topology/core_sibilings_list
echo 0-5 > /sys/bus/cpu/devices/cpu4/topology/core_sibilings_list

# disable sched overide for top-app and opt
echo 0 > /dev/stune/top-app/schedtune.sched_boost_no_override
echo 1 > /dev/cpuset/top-app/memory_migrate
echo 1 > /dev/cpuset/top-app/memory_spread_page

# memory tweaker
echo 1 > /dev/memcg/memory.use_hierarchy
echo 1 > /dev/memcg/apps/memory.move_charge_at_immigrate

# better sched and kernel
echo 1 > dev/stune/rt/schedtune.colocate
echo 90 > /dev/stune/top-app/schedtune.boost

# sysctl
sysctl -w kernel.sched_min_granularity_ns=10000000
sysctl -w kernel.sched_wakeup_granularity_ns=15000000
sysctl -w dev.i915.perf_stream_paranoid=0
sysctl -w dev.dri.card0.i915_enable_rc6=1
sysctl -w vm.swappiness=10
sysctl -w vm.vfs_cache_pressure=50

# simple network tweak
echo "2" > /proc/sys/net/ipv4/tcp_ecn
echo "1" > /proc/sys/net/ipv4/tcp_low_latency

soc_info=$(cat /proc/cpuinfo | grep 'Hardware' | awk '{print $3}')
if [[ $soc_info == "Qualcomm" ]]; then
  echo "Qualcomm SoC detected."
  echo 0 > /sys/class/kgsl/kgsl-3d0/throttling
  echo 95 > /sys/devices/system/cpu/cpufreq/schedutil/go_hispeed_load
  echo 1 > /sys/devices/system/cpu/cpufreq/policy0/schedutil/iowait_boost_enable
  echo 0 > /sys/devices/system/cpu/cpufreq/policy0/schedutil/up_rate_limit_us
  echo 10000 > /sys/devices/system/cpu/cpufreq/policy0/schedutil/down_rate_limit_us
  echo 1 > /sys/class/kgsl/kgsl-3d0/force_bus_on
  echo 1 > /sys/class/kgsl/kgsl-3d0/force_rail_on
elif [[ $soc_info == "MediaTek" ]]; then
  echo "MediaTek SoC detected."
  echo 0 > /proc/sys/vm/drop_caches
  echo0 0 > /proc/ppm/enabled
  echo 0 > /proc/sys/kernel/panic_on_oops
  echo 1 > /proc/sys/kernel/sched_tunable_scaling
  echo 90 > /proc/sys/kernel/sched_upmigrate
  echo 85 > /proc/sys/kernel/sched_downmigrate
else
  echo "Unknown SoC detected."
  # Tidak ada tweak yang akan ditambahkan
fi
# Function To Execute Preload
nohup sh $MODDIR/script/preload.sh &

exit 0